' Roland MT-32 LCD Message program

CLS
PRINT "Roland MT-32 LCD SysEx Message Generator"
PRINT "Version 1.2 by Anatoly Shashkin, 2019."
PRINT ""
PRINT "Enter 20 character message to display."
PRINT "Enter nothing to exit."
PRINT "Enter /dump to enable/disable compatibility mode."
PRINT ""
dump = 0

beginning:
LINE INPUT "Enter message: ", lcd$
IF LEN(lcd$) > 20 THEN
        PRINT "The message is too long."
        GOTO beginning
END IF
IF LEN(lcd$) = 0 THEN END

IF lcd$ = "/dump" THEN
        IF dump = 0 THEN
                    dump = 1
                    PRINT "Compatibility mode enabled."
                    ELSE
                    dump = 0
                    PRINT "Compatibility mode disabled."
        END IF
        GOTO beginning
END IF


'Center text
IF LEN(lcd$) < 20 THEN
        a = (20 - LEN(lcd$)) / 2
        lcd$ = LEFT$("                    ", a) + lcd$
        lcd$ = lcd$ + (LEFT$("                    ", 20 - LEN(lcd$)))
END IF

'Generate Roland checksum
checksum = &H20
FOR i = 1 TO 20
    checksum = checksum + ASC(MID$(lcd$, i, 1))
    IF checksum > 128 THEN checksum = checksum - 128
NEXT
checksum = 128 - checksum

' Generate SysEx message & send it on its way
sysex$ = CHR$(&HF0) + CHR$(&H41) + CHR$(&H10) + CHR$(&H16) + CHR$(&H12) + CHR$(&H20) + CHR$(&H0) + CHR$(&H0) + lcd$ + CHR$(checksum) + CHR$(&HF7)

IF dump = 0 THEN
        OUT &H331, &HDF
        FOR i = 1 TO LEN(sysex$)
                OUT &H330, ASC(MID$(sysex$, i, 1))
        NEXT
                ELSE
        OPEN "message.syx" FOR OUTPUT AS #1
        PRINT #1, sysex$
        CLOSE #1
        SHELL "dump message.syx"
END IF

GOTO beginning

' That's all, folks!
END

